## meshoptimizer 0.15%2Bdfsg

=== Makefile ===
MAKEFLAGS+=-r -j
COMMA=,

config=debug
files=demo/pirate.obj

BUILD=build/$(config)

LIBRARY_SOURCES=$(wildcard src/*.cpp)
LIBRARY_OBJECTS=$(LIBRARY_SOURCES:%=$(BUILD)/%.o)

DEMO_SOURCES=$(wildcard demo/*.c demo/*.cpp) tools/meshloader.cpp
DEMO_OBJECTS=$(DEMO_SOURCES:%=$(BUILD)/%.o)

GLTFPACK_SOURCES=$(wildcard gltf/*.cpp) tools/meshloader.cpp
GLTFPACK_OBJECTS=$(GLTFPACK_SOURCES:%=$(BUILD)/%.o)

OBJECTS=$(LIBRARY_OBJECTS) $(DEMO_OBJECTS) $(GLTFPACK_OBJECTS)

LIBRARY=$(BUILD)/libmeshoptimizer.a
EXECUTABLE=$(BUILD)/meshoptimizer

CFLAGS=-g -Wall -Wextra -Werror -std=c89
CXXFLAGS=-g -Wall -Wextra -Wshadow -Wno-missing-field-initializers -Werror -std=c++98
LDFLAGS=

WASMCC=clang++
WASI_SDK=

WASM_SOURCES=src/vertexcodec.cpp src/indexcodec.cpp src/vertexfilter.cpp tools/wasmstubs.cpp
WASM_EXPORTS=meshopt_decodeVertexBuffer meshopt_decodeIndexBuffer meshopt_decodeIndexSequence meshopt_decodeFilterOct meshopt_decodeFilterQuat meshopt_decodeFilterExp sbrk __wasm_call_ctors
WASM_FLAGS=--target=wasm32-wasi --sysroot=$(WASI_SDK)
WASM_FLAGS+=$(patsubst %,-Wl$(COMMA)--export=%,$(WASM_EXPORTS))
WASM_FLAGS+=-O3 -DNDEBUG -nostartfiles -nostdlib -Wl,--no-entry -Wl,-s
WASM_FLAGS+=-Wl,-z -Wl,stack-size=24576 -Wl,--initial-memory=65536

ifeq ($(config),iphone)
	IPHONESDK=/Applications/Xcode.app/Contents/Developer/Platforms/iPhoneOS.platform/Developer/SDKs/iPhoneOS.sdk
	CFLAGS+=-arch armv7 -arch arm64 -isysroot $(IPHONESDK)
	CXXFLAGS+=-arch armv7 -arch arm64 -isysroot $(IPHONESDK) -stdlib=libc++
	LDFLAGS+=-arch armv7 -arch arm64 -isysroot $(IPHONESDK) -L $(IPHONESDK)/usr/lib -mios-version-min=7.0
endif

ifeq ($(config),trace)
	CXXFLAGS+=-DTRACE=2
endif

ifeq ($(config),scalar)
	CXXFLAGS+=-O3 -DNDEBUG -DMESHOPTIMIZER_NO_SIMD
endif

ifeq ($(config),release)
	CXXFLAGS+=-O3 -DNDEBUG
endif

ifeq ($(config),coverage)
	CXXFLAGS+=-coverage
	LDFLAGS+=-coverage
endif

ifeq ($(config),sanitize)
	CXXFLAGS+=-fsanitize=address,undefined -fno-sanitize-recover=all
	LDFLAGS+=-fsanitize=address,undefined
endif

ifeq ($(config),analyze)
	CXXFLAGS+=--analyze
endif

all: $(EXECUTABLE)

test: $(EXECUTABLE)
	$(EXECUTABLE) $(files)

check: $(EXECUTABLE)
	$(EXECUTABLE)

dev: $(EXECUTABLE)
	$(EXECUTABLE) -d $(files)

format:
	clang-format -i $(LIBRARY_SOURCES) $(DEMO_SOURCES) $(GLTFPACK_SOURCES)

gltfpack: $(GLTFPACK_OBJECTS) $(LIBRARY)
	$(CXX) $^ $(LDFLAGS) -o $@

gltfpack.wasm: gltf/library.wasm

gltf/library.wasm: ${LIBRARY_SOURCES} ${GLTFPACK_SOURCES} tools/meshloader.cpp
	$(WASMCC) $^ -o $@ -Os -DNDEBUG --target=wasm32-wasi --sysroot=$(WASI_SDK) -nostartfiles -Wl,--no-entry -Wl,--export=pack -Wl,--export=malloc -Wl,--export=free -Wl,--export=__wasm_call_ctors -Wl,-s -Wl,--allow-undefined-file=gltf/wasistubs.txt

build/decoder_base.wasm: $(WASM_SOURCES)
	@mkdir -p build
	$(WASMCC) $^ $(WASM_FLAGS) -o $@

build/decoder_simd.wasm: $(WASM_SOURCES)
	@mkdir -p build
	$(WASMCC) $^ $(WASM_FLAGS) -o $@ -msimd128 -mbulk-memory

js/meshopt_decoder.js: build/decoder_base.wasm build/decoder_simd.wasm
	sed -i "s#Built with clang.*#Built with $$($(WASMCC) --version | head -n 1)#" $@
	sed -i "s#\(var wasm_base = \)\".*\";#\\1\"$$(cat build/decoder_base.wasm | python3 tools/wasmpack.py)\";#" $@
	sed -i "s#\(var wasm_simd = \)\".*\";#\\1\"$$(cat build/decoder_simd.wasm | python3 tools/wasmpack.py)\";#" $@

js/meshopt_decoder.module.js: js/meshopt_decoder.js
	sed '/UMD-style export/,$$d' <$< >$@
	echo "export { MeshoptDecoder };" >>$@

$(EXECUTABLE): $(DEMO_OBJECTS) $(LIBRARY)
	$(CXX) $^ $(LDFLAGS) -o $@

vcachetuner: tools/vcachetuner.cpp $(BUILD)/tools/meshloader.cpp.o $(BUILD)/demo/miniz.cpp.o $(LIBRARY)
	$(CXX) $^ -fopenmp $(CXXFLAGS) -std=c++11 $(LDFLAGS) -o $@

codecbench: tools/codecbench.cpp $(LIBRARY)
	$(CXX) $^ $(CXXFLAGS) $(LDFLAGS) -o $@

codecbench.js codecbench.wasm: tools/codecbench.cpp ${LIBRARY_SOURCES}
	emcc $^ -O3 -g -DNDEBUG -s TOTAL_MEMORY=268435456 -o $@

codecbench-simd.js codecbench-simd.wasm: tools/codecbench.cpp ${LIBRARY_SOURCES}
	emcc $^ -O3 -g -DNDEBUG -s TOTAL_MEMORY=268435456 -msimd128 -o $@

$(LIBRARY): $(LIBRARY_OBJECTS)
	ar rcs $@ $^

$(BUILD)/%.cpp.o: %.cpp
	@mkdir -p $(dir $@)
	$(CXX) $< $(CXXFLAGS) -c -MMD -MP -o $@

$(BUILD)/%.c.o: %.c
	@mkdir -p $(dir $@)
	$(CC) $< $(CFLAGS) -c -MMD -MP -o $@

-include $(OBJECTS:.o=.d)

clean:
	rm -rf $(BUILD)

.PHONY: all clean format

## meshoptimizer 0.15+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

if (NOT CMAKE_VERSION VERSION_LESS 3.12)
    cmake_policy(SET CMP0077 NEW) # Enables override of options from parent CMakeLists.txt
endif()

if (NOT CMAKE_VERSION VERSION_LESS 3.15)
    cmake_policy(SET CMP0091 NEW) # Enables use of MSVC_RUNTIME_LIBRARY
    cmake_policy(SET CMP0092 NEW) # Enables clean /W4 override for MSVC
endif()

project(meshoptimizer VERSION 0.15 LANGUAGES CXX)

option(MESHOPT_BUILD_DEMO "Build demo" OFF)
option(MESHOPT_BUILD_GLTFPACK "Build gltfpack" OFF)
option(MESHOPT_BUILD_SHARED_LIBS "Build shared libraries" OFF)

# add_library() needs BUILD_SHARED_LIBS set to decide between static and
# shared. This also sets it back to OFF in case parent project has
# BUILD_SHARED_LIBS but wants MESHOPT_BUILD_SHARED_LIBS to be OFF.
set(BUILD_SHARED_LIBS ${MESHOPT_BUILD_SHARED_LIBS})

set(SOURCES
    src/meshoptimizer.h
    src/allocator.cpp
    src/clusterizer.cpp
    src/indexcodec.cpp
    src/indexgenerator.cpp
    src/overdrawanalyzer.cpp
    src/overdrawoptimizer.cpp
    src/simplifier.cpp
    src/spatialorder.cpp
    src/stripifier.cpp
    src/vcacheanalyzer.cpp
    src/vcacheoptimizer.cpp
    src/vertexcodec.cpp
    src/vertexfilter.cpp
    src/vfetchanalyzer.cpp
    src/vfetchoptimizer.cpp
)

set(GLTF_SOURCES
    gltf/animation.cpp
    gltf/basistoktx.cpp
    gltf/fileio.cpp
    gltf/gltfpack.cpp
    gltf/image.cpp
    gltf/json.cpp
    gltf/material.cpp
    gltf/mesh.cpp
    gltf/node.cpp
    gltf/parseobj.cpp
    gltf/parsegltf.cpp
    gltf/stream.cpp
    gltf/write.cpp
)

if(MSVC)
    add_compile_options(/W4 /WX)
else()
    add_compile_options(-Wall -Wextra -Wshadow -Wno-missing-field-initializers -Werror)
endif()

add_library(meshoptimizer ${SOURCES})
target_include_directories(meshoptimizer INTERFACE "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/src>")

if(MESHOPT_BUILD_SHARED_LIBS)
    set_target_properties(meshoptimizer PROPERTIES CXX_VISIBILITY_PRESET hidden)
    set_target_properties(meshoptimizer PROPERTIES VISIBILITY_INLINES_HIDDEN ON)

    if(WIN32)
        target_compile_definitions(meshoptimizer INTERFACE "MESHOPTIMIZER_API=__declspec(dllimport)")
        target_compile_definitions(meshoptimizer PRIVATE "MESHOPTIMIZER_API=__declspec(dllexport)")
    else()
        target_compile_definitions(meshoptimizer PUBLIC "MESHOPTIMIZER_API=__attribute__((visibility(\"default\")))")
    endif()
endif()

set(TARGETS meshoptimizer)

if(MESHOPT_BUILD_DEMO)
    add_executable(demo demo/main.cpp demo/miniz.cpp demo/tests.cpp tools/meshloader.cpp)
    target_link_libraries(demo meshoptimizer)
endif()

if(MESHOPT_BUILD_GLTFPACK)
    add_executable(gltfpack ${GLTF_SOURCES} tools/meshloader.cpp)
    target_link_libraries(gltfpack meshoptimizer)
    list(APPEND TARGETS gltfpack)

    if(MESHOPT_BUILD_SHARED_LIBS)
        string(CONCAT RPATH "$ORIGIN/../" ${CMAKE_INSTALL_LIBDIR})
        set_target_properties(gltfpack PROPERTIES INSTALL_RPATH ${RPATH})
    endif()
endif()

include(GNUInstallDirs)

install(TARGETS ${TARGETS} EXPORT meshoptimizerTargets
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

install(FILES src/meshoptimizer.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
install(EXPORT meshoptimizerTargets DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/meshoptimizer NAMESPACE meshoptimizer::)

# TARGET_PDB_FILE is available since 3.1
if(MSVC AND NOT (CMAKE_VERSION VERSION_LESS "3.1"))
    foreach(TARGET ${TARGETS})
        get_target_property(TARGET_TYPE ${TARGET} TYPE)
        if(NOT ${TARGET_TYPE} STREQUAL "STATIC_LIBRARY")
            install(FILES $<TARGET_PDB_FILE:${TARGET}> DESTINATION ${CMAKE_INSTALL_BINDIR} OPTIONAL)
        endif()
    endforeach(TARGET)
endif()

include(CMakePackageConfigHelpers)

configure_package_config_file(config.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/meshoptimizerConfig.cmake
    INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/meshoptimizer NO_SET_AND_CHECK_MACRO)

write_basic_package_version_file(${CMAKE_CURRENT_BINARY_DIR}/meshoptimizerConfigVersion.cmake COMPATIBILITY ExactVersion)

install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/meshoptimizerConfig.cmake
    ${CMAKE_CURRENT_BINARY_DIR}/meshoptimizerConfigVersion.cmake
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/meshoptimizer)

=== debian/changelog ===
meshoptimizer (0.15+dfsg-3) unstable; urgency=medium

  * Fix keyword error in d/watch

 -- Timo Röhling <timo@gaussglocke.de>  Thu, 07 Jan 2021 17:32:18 +0100

meshoptimizer (0.15+dfsg-2) unstable; urgency=medium

  * Source only upload.

 -- Timo Röhling <timo@gaussglocke.de>  Fri, 25 Dec 2020 16:50:50 +0100

meshoptimizer (0.15+dfsg-1) unstable; urgency=medium

  * Initial release (Closes: #977129)

 -- Timo Röhling <timo@gaussglocke.de>  Sun, 13 Dec 2020 20:29:32 +0100

=== debian/control ===
Source: meshoptimizer
Section: graphics
Priority: optional
Maintainer: Timo Röhling <timo@gaussglocke.de>
Build-Depends: debhelper-compat (= 13), cmake
Homepage: https://github.com/zeux/meshoptimizer
Standards-Version: 4.5.1
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/roehling/meshoptimizer.git
Vcs-Browser: https://salsa.debian.org/roehling/meshoptimizer

Package: libmeshoptimizer0d
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Mesh optimizing library for 3D object rendering
 When a GPU renders triangle meshes, various stages of the GPU pipeline have
 to process vertex and index data. The efficiency of these stages depends on
 the data you feed to them; this library provides algorithms to help optimize
 meshes for these stages, as well as algorithms to reduce the mesh complexity
 and storage overhead.

Package: libmeshoptimizer-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libmeshoptimizer0d (= ${binary:Version}), ${misc:Depends}
Description: Mesh optimizing library for 3D object rendering - development headers
 When a GPU renders triangle meshes, various stages of the GPU pipeline have
 to process vertex and index data. The efficiency of these stages depends on
 the data you feed to them; this library provides algorithms to help optimize
 meshes for these stages, as well as algorithms to reduce the mesh complexity
 and storage overhead.
 .
 This package provides the development headers for the library.

Package: gltfpack
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: glTF mesh file optimizer
 gltfpack is a tool that can automatically optimize glTF files to reduce the
 download size and improve loading and rendering speed.
 .
 It substantially changes the glTF data by optimizing the meshes for
 vertex fetch and transform cache, quantizing the geometry to reduce the
 memory consumption and size, merging meshes to reduce the draw call count,
 quantizing and resampling animations to reduce animation size and simplify
 playback, and pruning the node tree by removing or collapsing redundant
 nodes. It will also simplify the meshes when requested to do so.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all reproducible=+all future=+lfs

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake -- \
		-DMESHOPT_BUILD_DEMO=OFF \
		-DMESHOPT_BUILD_GLTFPACK=ON \
		-DMESHOPT_BUILD_SHARED_LIBS=ON \
		-DCMAKE_SKIP_RPATH=ON

## meshoptimizer 0.16+dfsg

=== Makefile ===
--- 
+++ 
@@ -42,7 +42,7 @@
 endif
 
 ifeq ($(config),trace)
-	CXXFLAGS+=-DTRACE=2
+	CXXFLAGS+=-DTRACE=1
 endif
 
 ifeq ($(config),scalar)
@@ -121,6 +121,9 @@
 codecbench-simd.js codecbench-simd.wasm: tools/codecbench.cpp ${LIBRARY_SOURCES}
 	emcc $^ -O3 -g -DNDEBUG -s TOTAL_MEMORY=268435456 -msimd128 -o $@
 
+codecfuzz: tools/codecfuzz.cpp src/vertexcodec.cpp src/indexcodec.cpp
+	$(CXX) $^ -fsanitize=fuzzer,address,undefined -O1 -g -o $@
+
 $(LIBRARY): $(LIBRARY_OBJECTS)
 	ar rcs $@ $^

=== debian/changelog ===
meshoptimizer (0.16+dfsg-2) unstable; urgency=medium

  * Upload to unstable.

 -- Timo Röhling <roehling@debian.org>  Sun, 15 Aug 2021 23:01:24 +0200

meshoptimizer (0.16+dfsg-1) experimental; urgency=medium

  * New upstream version 0.16+dfsg
  * Bump SOVERSION to 1d
  * Update maintainer info

 -- Timo Röhling <roehling@debian.org>  Thu, 03 Jun 2021 07:40:35 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: meshoptimizer
 Section: graphics
 Priority: optional
-Maintainer: Timo Röhling <timo@gaussglocke.de>
+Maintainer: Timo Röhling <roehling@debian.org>
 Build-Depends: debhelper-compat (= 13), cmake
 Homepage: https://github.com/zeux/meshoptimizer
 Standards-Version: 4.5.1
@@ -9,7 +9,7 @@
 Vcs-Git: https://salsa.debian.org/roehling/meshoptimizer.git
 Vcs-Browser: https://salsa.debian.org/roehling/meshoptimizer
 
-Package: libmeshoptimizer0d
+Package: libmeshoptimizer1d
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -25,7 +25,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libmeshoptimizer0d (= ${binary:Version}), ${misc:Depends}
+Depends: libmeshoptimizer1d (= ${binary:Version}), ${misc:Depends}
 Description: Mesh optimizing library for 3D object rendering - development headers
  When a GPU renders triangle meshes, various stages of the GPU pipeline have
  to process vertex and index data. The efficiency of these stages depends on

## meshoptimizer 0.17+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,24 +1,21 @@
 cmake_minimum_required(VERSION 3.0)
 
-if (NOT CMAKE_VERSION VERSION_LESS 3.12)
+if(POLICY CMP0077)
     cmake_policy(SET CMP0077 NEW) # Enables override of options from parent CMakeLists.txt
 endif()
 
-if (NOT CMAKE_VERSION VERSION_LESS 3.15)
+if(POLICY CMP0091)
     cmake_policy(SET CMP0091 NEW) # Enables use of MSVC_RUNTIME_LIBRARY
+endif()
+if(POLICY CMP0092)
     cmake_policy(SET CMP0092 NEW) # Enables clean /W4 override for MSVC
 endif()
 
-project(meshoptimizer VERSION 0.15 LANGUAGES CXX)
+project(meshoptimizer VERSION 0.17 LANGUAGES CXX)
 
 option(MESHOPT_BUILD_DEMO "Build demo" OFF)
 option(MESHOPT_BUILD_GLTFPACK "Build gltfpack" OFF)
 option(MESHOPT_BUILD_SHARED_LIBS "Build shared libraries" OFF)
-
-# add_library() needs BUILD_SHARED_LIBS set to decide between static and
-# shared. This also sets it back to OFF in case parent project has
-# BUILD_SHARED_LIBS but wants MESHOPT_BUILD_SHARED_LIBS to be OFF.
-set(BUILD_SHARED_LIBS ${MESHOPT_BUILD_SHARED_LIBS})
 
 set(SOURCES
     src/meshoptimizer.h
@@ -41,7 +38,6 @@
 
 set(GLTF_SOURCES
     gltf/animation.cpp
-    gltf/basistoktx.cpp
     gltf/fileio.cpp
     gltf/gltfpack.cpp
     gltf/image.cpp
@@ -61,7 +57,12 @@
     add_compile_options(-Wall -Wextra -Wshadow -Wno-missing-field-initializers -Werror)
 endif()
 
-add_library(meshoptimizer ${SOURCES})
+if(MESHOPT_BUILD_SHARED_LIBS)
+    add_library(meshoptimizer SHARED ${SOURCES})
+else()
+    add_library(meshoptimizer STATIC ${SOURCES})
+endif()
+
 target_include_directories(meshoptimizer INTERFACE "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/src>")
 
 if(MESHOPT_BUILD_SHARED_LIBS)
@@ -79,12 +80,13 @@
 set(TARGETS meshoptimizer)
 
 if(MESHOPT_BUILD_DEMO)
-    add_executable(demo demo/main.cpp demo/miniz.cpp demo/tests.cpp tools/meshloader.cpp)
+    add_executable(demo demo/main.cpp demo/tests.cpp tools/meshloader.cpp)
     target_link_libraries(demo meshoptimizer)
 endif()
 
 if(MESHOPT_BUILD_GLTFPACK)
     add_executable(gltfpack ${GLTF_SOURCES} tools/meshloader.cpp)
+    set_target_properties(gltfpack PROPERTIES CXX_STANDARD 11)
     target_link_libraries(gltfpack meshoptimizer)
     list(APPEND TARGETS gltfpack)

=== debian/changelog ===
meshoptimizer (0.17+dfsg-1) unstable; urgency=medium

  * New upstream version 0.17+dfsg
  * Refresh patches
  * Add .symbols file
  * Bump Standards-Version to 4.6.0
  * Update d/copyright

 -- Timo Röhling <roehling@debian.org>  Thu, 25 Nov 2021 13:02:03 +0100

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Timo Röhling <roehling@debian.org>
 Build-Depends: debhelper-compat (= 13), cmake
 Homepage: https://github.com/zeux/meshoptimizer
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/roehling/meshoptimizer.git
 Vcs-Browser: https://salsa.debian.org/roehling/meshoptimizer

=== debian/rules ===
--- 
+++ 
@@ -10,4 +10,5 @@
 		-DMESHOPT_BUILD_DEMO=OFF \
 		-DMESHOPT_BUILD_GLTFPACK=ON \
 		-DMESHOPT_BUILD_SHARED_LIBS=ON \
+		-DMESHOPT_SOVERSION=1d \
 		-DCMAKE_SKIP_RPATH=ON

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/@PACKAGE@-$1.tar.gz/,\
     dversionmangle=s/\+dfsg\d*$//,oversionmangle=s/$/+dfsg/,\
     repack \
https://github.com/zeux/meshoptimizer/releases/latest .*/v?(\d\S+)\.tar\.gz

## meshoptimizer 0.18+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -11,11 +11,12 @@
     cmake_policy(SET CMP0092 NEW) # Enables clean /W4 override for MSVC
 endif()
 
-project(meshoptimizer VERSION 0.17 LANGUAGES CXX)
+project(meshoptimizer VERSION 0.18 LANGUAGES CXX)
 
 option(MESHOPT_BUILD_DEMO "Build demo" OFF)
 option(MESHOPT_BUILD_GLTFPACK "Build gltfpack" OFF)
 option(MESHOPT_BUILD_SHARED_LIBS "Build shared libraries" OFF)
+set(MESHOPT_BASISU_PATH "" CACHE STRING "")
 
 set(SOURCES
     src/meshoptimizer.h
@@ -38,6 +39,8 @@
 
 set(GLTF_SOURCES
     gltf/animation.cpp
+    gltf/basisenc.cpp
+    gltf/basislib.cpp
     gltf/fileio.cpp
     gltf/gltfpack.cpp
     gltf/image.cpp
@@ -94,25 +97,41 @@
         string(CONCAT RPATH "$ORIGIN/../" ${CMAKE_INSTALL_LIBDIR})
         set_target_properties(gltfpack PROPERTIES INSTALL_RPATH ${RPATH})
     endif()
+
+    if(NOT MESHOPT_BASISU_PATH STREQUAL "")
+        get_filename_component(BASISU_PATH ${MESHOPT_BASISU_PATH} ABSOLUTE)
+
+        target_compile_definitions(gltfpack PRIVATE WITH_BASISU)
+        set_source_files_properties(gltf/basisenc.cpp gltf/basislib.cpp PROPERTIES INCLUDE_DIRECTORIES ${BASISU_PATH})
+
+        if(NOT MSVC AND CMAKE_HOST_SYSTEM_PROCESSOR STREQUAL "x86_64")
+            set_source_files_properties(gltf/basislib.cpp PROPERTIES COMPILE_OPTIONS -msse4.1)
+        endif()
+
+        if(UNIX)
+            target_link_libraries(gltfpack pthread)
+        endif()
+    endif()
 endif()
 
 include(GNUInstallDirs)
 
 install(TARGETS ${TARGETS} EXPORT meshoptimizerTargets
+    COMPONENT meshoptimizer
     RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
     LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
     ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
     INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
 
-install(FILES src/meshoptimizer.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
-install(EXPORT meshoptimizerTargets DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/meshoptimizer NAMESPACE meshoptimizer::)
+install(FILES src/meshoptimizer.h COMPONENT meshoptimizer DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
+install(EXPORT meshoptimizerTargets COMPONENT meshoptimizer DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/meshoptimizer NAMESPACE meshoptimizer::)
 
 # TARGET_PDB_FILE is available since 3.1
 if(MSVC AND NOT (CMAKE_VERSION VERSION_LESS "3.1"))
     foreach(TARGET ${TARGETS})
         get_target_property(TARGET_TYPE ${TARGET} TYPE)
         if(NOT ${TARGET_TYPE} STREQUAL "STATIC_LIBRARY")
-            install(FILES $<TARGET_PDB_FILE:${TARGET}> DESTINATION ${CMAKE_INSTALL_BINDIR} OPTIONAL)
+            install(FILES $<TARGET_PDB_FILE:${TARGET}> COMPONENT meshoptimizer DESTINATION ${CMAKE_INSTALL_BINDIR} OPTIONAL)
         endif()
     endforeach(TARGET)
 endif()
@@ -128,4 +147,5 @@
 install(FILES
     ${CMAKE_CURRENT_BINARY_DIR}/meshoptimizerConfig.cmake
     ${CMAKE_CURRENT_BINARY_DIR}/meshoptimizerConfigVersion.cmake
+    COMPONENT meshoptimizer
     DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/meshoptimizer)

=== debian/changelog ===
meshoptimizer (0.18+dfsg-2) unstable; urgency=medium

  * Upload to unstable.

 -- Timo Röhling <roehling@debian.org>  Sun, 07 Aug 2022 22:38:11 +0200

meshoptimizer (0.18+dfsg-1) experimental; urgency=medium

  * Set upstream metadata fields
  * New upstream version 0.18+dfsg
  * Bump SONAME after ABI change
  * Bump Standards-Version to 4.6.1

 -- Timo Röhling <roehling@debian.org>  Thu, 04 Aug 2022 22:45:53 +0200

=== debian/control ===
--- 
+++ 
@@ -4,12 +4,12 @@
 Maintainer: Timo Röhling <roehling@debian.org>
 Build-Depends: debhelper-compat (= 13), cmake
 Homepage: https://github.com/zeux/meshoptimizer
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/roehling/meshoptimizer.git
 Vcs-Browser: https://salsa.debian.org/roehling/meshoptimizer
 
-Package: libmeshoptimizer1d
+Package: libmeshoptimizer2d
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -25,7 +25,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libmeshoptimizer1d (= ${binary:Version}), ${misc:Depends}
+Depends: libmeshoptimizer2d (= ${binary:Version}), ${misc:Depends}
 Description: Mesh optimizing library for 3D object rendering - development headers
  When a GPU renders triangle meshes, various stages of the GPU pipeline have
  to process vertex and index data. The efficiency of these stages depends on

=== debian/rules ===
--- 
+++ 
@@ -10,5 +10,5 @@
 		-DMESHOPT_BUILD_DEMO=OFF \
 		-DMESHOPT_BUILD_GLTFPACK=ON \
 		-DMESHOPT_BUILD_SHARED_LIBS=ON \
-		-DMESHOPT_SOVERSION=1d \
+		-DMESHOPT_SOVERSION=2d \
 		-DCMAKE_SKIP_RPATH=ON

## meshoptimizer 0.19+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -11,11 +11,12 @@
     cmake_policy(SET CMP0092 NEW) # Enables clean /W4 override for MSVC
 endif()
 
-project(meshoptimizer VERSION 0.18 LANGUAGES CXX)
+project(meshoptimizer VERSION 0.19 LANGUAGES CXX)
 
 option(MESHOPT_BUILD_DEMO "Build demo" OFF)
 option(MESHOPT_BUILD_GLTFPACK "Build gltfpack" OFF)
 option(MESHOPT_BUILD_SHARED_LIBS "Build shared libraries" OFF)
+option(MESHOPT_WERROR "Treat warnings as errors" OFF)
 set(MESHOPT_BASISU_PATH "" CACHE STRING "")
 
 set(SOURCES
@@ -55,9 +56,17 @@
 )
 
 if(MSVC)
-    add_compile_options(/W4 /WX)
+    add_compile_options(/W4)
 else()
-    add_compile_options(-Wall -Wextra -Wshadow -Wno-missing-field-initializers -Werror)
+    add_compile_options(-Wall -Wextra -Wshadow -Wno-missing-field-initializers)
+endif()
+
+if(MESHOPT_WERROR)
+    if(MSVC)
+        add_compile_options(/WX)
+    else()
+        add_compile_options(-Werror)
+    endif()
 endif()
 
 if(MESHOPT_BUILD_SHARED_LIBS)

=== debian/changelog ===
meshoptimizer (0.19+dfsg-1) unstable; urgency=medium

  * Fix d/watch
  * New upstream version 0.19+dfsg
  * Refresh patches
  * Bump experimental symbol
  * Update d/copyright
  * Bump Standards-Version to 4.6.2

 -- Timo Röhling <roehling@debian.org>  Tue, 27 Jun 2023 00:30:49 +0200

## meshoptimizer 0.20%2Bdfsg

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/@PACKAGE@-$1.tar.gz/,\
     dversionmangle=s/\+dfsg\d*$//,oversionmangle=s/$/+dfsg/,\
     repack \
https://github.com/zeux/meshoptimizer/tags .*/v?(\d\S+)\.tar\.gz

## meshoptimizer 0.20+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.0)
+cmake_minimum_required(VERSION 3.5)
 
 if(POLICY CMP0077)
     cmake_policy(SET CMP0077 NEW) # Enables override of options from parent CMakeLists.txt
@@ -7,11 +7,12 @@
 if(POLICY CMP0091)
     cmake_policy(SET CMP0091 NEW) # Enables use of MSVC_RUNTIME_LIBRARY
 endif()
+
 if(POLICY CMP0092)
     cmake_policy(SET CMP0092 NEW) # Enables clean /W4 override for MSVC
 endif()
 
-project(meshoptimizer VERSION 0.19 LANGUAGES CXX)
+project(meshoptimizer VERSION 0.20 LANGUAGES CXX)
 
 option(MESHOPT_BUILD_DEMO "Build demo" OFF)
 option(MESHOPT_BUILD_GLTFPACK "Build gltfpack" OFF)
@@ -27,6 +28,7 @@
     src/indexgenerator.cpp
     src/overdrawanalyzer.cpp
     src/overdrawoptimizer.cpp
+    src/quantization.cpp
     src/simplifier.cpp
     src/spatialorder.cpp
     src/stripifier.cpp
@@ -50,6 +52,7 @@
     gltf/mesh.cpp
     gltf/node.cpp
     gltf/parseobj.cpp
+    gltf/parselib.cpp
     gltf/parsegltf.cpp
     gltf/stream.cpp
     gltf/write.cpp
@@ -92,12 +95,12 @@
 set(TARGETS meshoptimizer)
 
 if(MESHOPT_BUILD_DEMO)
-    add_executable(demo demo/main.cpp demo/tests.cpp tools/meshloader.cpp)
+    add_executable(demo demo/main.cpp demo/tests.cpp tools/objloader.cpp)
     target_link_libraries(demo meshoptimizer)
 endif()
 
 if(MESHOPT_BUILD_GLTFPACK)
-    add_executable(gltfpack ${GLTF_SOURCES} tools/meshloader.cpp)
+    add_executable(gltfpack ${GLTF_SOURCES})
     set_target_properties(gltfpack PROPERTIES CXX_STANDARD 11)
     target_link_libraries(gltfpack meshoptimizer)
     list(APPEND TARGETS gltfpack)

=== debian/changelog ===
meshoptimizer (0.20+dfsg-1) unstable; urgency=medium

  * New upstream version 0.20+dfsg
  * Update d/symbols

 -- Timo Röhling <roehling@debian.org>  Mon, 06 Nov 2023 19:10:42 +0100

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Timo Röhling <roehling@debian.org>
 Build-Depends: debhelper-compat (= 13), cmake
 Homepage: https://github.com/zeux/meshoptimizer
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/roehling/meshoptimizer.git
 Vcs-Browser: https://salsa.debian.org/roehling/meshoptimizer

## meshoptimizer 0.21+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -12,7 +12,7 @@
     cmake_policy(SET CMP0092 NEW) # Enables clean /W4 override for MSVC
 endif()
 
-project(meshoptimizer VERSION 0.20 LANGUAGES CXX)
+project(meshoptimizer VERSION 0.21 LANGUAGES CXX)
 
 option(MESHOPT_BUILD_DEMO "Build demo" OFF)
 option(MESHOPT_BUILD_GLTFPACK "Build gltfpack" OFF)
@@ -83,6 +83,11 @@
 if(MESHOPT_BUILD_SHARED_LIBS)
     set_target_properties(meshoptimizer PROPERTIES CXX_VISIBILITY_PRESET hidden)
     set_target_properties(meshoptimizer PROPERTIES VISIBILITY_INLINES_HIDDEN ON)
+
+    # soversion may be requested via -DMESHOPT_SOVERSION=n; note that experimental APIs (marked with MESHOPTIMIZER_EXPERIMENTAL) are not ABI-stable
+    if(MESHOPT_SOVERSION)
+        set_target_properties(meshoptimizer PROPERTIES VERSION ${PROJECT_VERSION} SOVERSION ${MESHOPT_SOVERSION})
+    endif()
 
     if(WIN32)
         target_compile_definitions(meshoptimizer INTERFACE "MESHOPTIMIZER_API=__declspec(dllimport)")

=== debian/changelog ===
meshoptimizer (0.21+dfsg-1) unstable; urgency=medium

  * New upstream version 0.21+dfsg
  * Refresh patches (no functional changes)
  * Update d/copyright
  * Update d/symbols

 -- Timo Röhling <roehling@debian.org>  Sat, 29 Jun 2024 22:40:32 +0200

## meshoptimizer 0.22+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -12,7 +12,7 @@
     cmake_policy(SET CMP0092 NEW) # Enables clean /W4 override for MSVC
 endif()
 
-project(meshoptimizer VERSION 0.21 LANGUAGES CXX)
+project(meshoptimizer VERSION 0.22 LANGUAGES CXX)
 
 option(MESHOPT_BUILD_DEMO "Build demo" OFF)
 option(MESHOPT_BUILD_GLTFPACK "Build gltfpack" OFF)
@@ -58,6 +58,10 @@
     gltf/write.cpp
 )
 
+if(WIN32)
+    list(APPEND GLTF_SOURCES gltf/gltfpack.manifest)
+endif()
+
 if(MSVC)
     add_compile_options(/W4)
 else()
@@ -100,7 +104,7 @@
 set(TARGETS meshoptimizer)
 
 if(MESHOPT_BUILD_DEMO)
-    add_executable(demo demo/main.cpp demo/tests.cpp tools/objloader.cpp)
+    add_executable(demo demo/main.cpp demo/nanite.cpp demo/tests.cpp tools/objloader.cpp)
     target_link_libraries(demo meshoptimizer)
 endif()

=== Makefile ===
MAKEFLAGS+=-r -j

config=debug
files=demo/pirate.obj

BUILD=build/$(config)

LIBRARY_SOURCES=$(wildcard src/*.cpp)
LIBRARY_OBJECTS=$(LIBRARY_SOURCES:%=$(BUILD)/%.o)

DEMO_SOURCES=$(wildcard demo/*.c demo/*.cpp) tools/objloader.cpp
DEMO_OBJECTS=$(DEMO_SOURCES:%=$(BUILD)/%.o)

GLTFPACK_SOURCES=$(wildcard gltf/*.cpp)
GLTFPACK_OBJECTS=$(GLTFPACK_SOURCES:%=$(BUILD)/%.o)

OBJECTS=$(LIBRARY_OBJECTS) $(DEMO_OBJECTS) $(GLTFPACK_OBJECTS)

LIBRARY=$(BUILD)/libmeshoptimizer.a
DEMO=$(BUILD)/meshoptimizer

CFLAGS=-g -Wall -Wextra -std=c89
CXXFLAGS=-g -Wall -Wextra -Wshadow -Wno-missing-field-initializers -std=gnu++98
LDFLAGS=

$(GLTFPACK_OBJECTS): CXXFLAGS+=-std=c++11

ifdef BASISU
    $(GLTFPACK_OBJECTS): CXXFLAGS+=-DWITH_BASISU
    $(BUILD)/gltf/basis%.cpp.o: CXXFLAGS+=-I$(BASISU)
    gltfpack: LDFLAGS+=-lpthread

    ifeq ($(HOSTTYPE),x86_64)
        $(BUILD)/gltf/basislib.cpp.o: CXXFLAGS+=-msse4.1
    endif
endif

ifdef METIS
    $(DEMO_OBJECTS): CXXFLAGS+=-DMETIS
    $(DEMO): LDFLAGS+=-lmetis
endif

WASMCC?=$(WASI_SDK)/bin/clang++
WASIROOT?=$(WASI_SDK)/share/wasi-sysroot

WASM_FLAGS=--target=wasm32-wasi --sysroot=$(WASIROOT)
WASM_FLAGS+=-Wall -Wextra
WASM_FLAGS+=-O3 -DNDEBUG -nostartfiles -nostdlib -Wl,--no-entry -Wl,-s
WASM_FLAGS+=-mcpu=mvp # make sure clang doesn't use post-MVP features like sign extension
WASM_FLAGS+=-fno-slp-vectorize -fno-vectorize -fno-unroll-loops
WASM_FLAGS+=-Wl,-z -Wl,stack-size=36864 -Wl,--initial-memory=65536
WASM_EXPORT_PREFIX=-Wl,--export

WASM_DECODER_SOURCES=src/vertexcodec.cpp src/indexcodec.cpp src/vertexfilter.cpp tools/wasmstubs.cpp
WASM_DECODER_EXPORTS=meshopt_decodeVertexBuffer meshopt_decodeIndexBuffer meshopt_decodeIndexSequence meshopt_decodeFilterOct meshopt_decodeFilterQuat meshopt_decodeFilterExp sbrk __wasm_call_ctors

WASM_ENCODER_SOURCES=src/vertexcodec.cpp src/indexcodec.cpp src/vertexfilter.cpp src/vcacheoptimizer.cpp src/vfetchoptimizer.cpp src/spatialorder.cpp tools/wasmstubs.cpp
WASM_ENCODER_EXPORTS=meshopt_encodeVertexBuffer meshopt_encodeVertexBufferBound meshopt_encodeIndexBuffer meshopt_encodeIndexBufferBound meshopt_encodeIndexSequence meshopt_encodeIndexSequenceBound meshopt_encodeVertexVersion meshopt_encodeIndexVersion meshopt_encodeFilterOct meshopt_encodeFilterQuat meshopt_encodeFilterExp meshopt_optimizeVertexCache meshopt_optimizeVertexCacheStrip meshopt_optimizeVertexFetchRemap meshopt_spatialSortRemap sbrk __wasm_call_ctors

WASM_SIMPLIFIER_SOURCES=src/simplifier.cpp src/vfetchoptimizer.cpp tools/wasmstubs.cpp
WASM_SIMPLIFIER_EXPORTS=meshopt_simplify meshopt_simplifyWithAttributes meshopt_simplifyScale meshopt_simplifyPoints meshopt_optimizeVertexFetchRemap sbrk __wasm_call_ctors

WASM_CLUSTERIZER_SOURCES=src/clusterizer.cpp tools/wasmstubs.cpp
WASM_CLUSTERIZER_EXPORTS=meshopt_buildMeshletsBound meshopt_buildMeshlets meshopt_computeClusterBounds meshopt_computeMeshletBounds meshopt_optimizeMeshlet sbrk __wasm_call_ctors

ifneq ($(werror),)
	CFLAGS+=-Werror
	CXXFLAGS+=-Werror
endif

ifeq ($(config),iphone)
	IPHONESDK=/Applications/Xcode.app/Contents/Developer/Platforms/iPhoneOS.platform/Developer/SDKs/iPhoneOS.sdk
	CFLAGS+=-arch armv7 -arch arm64 -isysroot $(IPHONESDK)
	CXXFLAGS+=-arch armv7 -arch arm64 -isysroot $(IPHONESDK) -stdlib=libc++
	LDFLAGS+=-arch armv7 -arch arm64 -isysroot $(IPHONESDK) -L $(IPHONESDK)/usr/lib -mios-version-min=7.0
endif

ifeq ($(config),trace)
	CXXFLAGS+=-DTRACE=1
endif

ifeq ($(config),scalar)
	CXXFLAGS+=-O3 -DNDEBUG -DMESHOPTIMIZER_NO_SIMD
endif

ifeq ($(config),release)
	CXXFLAGS+=-O3 -DNDEBUG
endif

ifeq ($(config),coverage)
	CXXFLAGS+=-coverage
	LDFLAGS+=-coverage
endif

ifeq ($(config),sanitize)
	CXXFLAGS+=-fsanitize=address,undefined -fsanitize-undefined-trap-on-error
	LDFLAGS+=-fsanitize=address,undefined
endif

ifeq ($(config),analyze)
	CXXFLAGS+=--analyze
endif

ifeq ($(config),fuzz)
    CXXFLAGS+=-O1 -fsanitize=address,fuzzer
    LDFLAGS+=-fsanitize=address,fuzzer

    $(GLTFPACK_OBJECTS): CXXFLAGS+=-DGLTFFUZZ
endif

all: $(DEMO)

test: $(DEMO)
	$(DEMO) $(files)

check: $(DEMO)
	$(DEMO)

dev: $(DEMO)
	$(DEMO) -d $(files)

nanite: $(DEMO)
	$(DEMO) -n $(files)

format:
	clang-format -i src/*.h src/*.cpp demo/*.cpp gltf/*.h gltf/*.cpp

formatjs:
	prettier -w js/*.js gltf/*.js demo/*.html js/*.ts

js: js/meshopt_decoder.js js/meshopt_decoder.module.js js/meshopt_encoder.js js/meshopt_encoder.module.js js/meshopt_simplifier.js js/meshopt_simplifier.module.js js/meshopt_clusterizer.js js/meshopt_clusterizer.module.js

symbols: $(BUILD)/amalgamated.so
	nm $< -U -g

gltfpack: $(BUILD)/gltfpack
	ln -fs $^ $@

ifeq ($(config),fuzz)
gltffuzz: $(BUILD)/gltfpack
	cp $^ $@
	mkdir -p /tmp/gltffuzz
	cp gltf/fuzz.glb /tmp/gltffuzz/
	./gltffuzz /tmp/gltffuzz -fork=16 -dict=gltf/fuzz.dict -ignore_crashes=1 -max_len=32768
endif

$(BUILD)/gltfpack: $(GLTFPACK_OBJECTS) $(LIBRARY)
	$(CXX) $^ $(LDFLAGS) -o $@

gltfpack.wasm: gltf/library.wasm

gltf/library.wasm: $(LIBRARY_SOURCES) $(GLTFPACK_SOURCES)
	$(WASMCC) $^ -o $@ -Wall -Os -DNDEBUG --target=wasm32-wasi --sysroot=$(WASIROOT) -nostartfiles -Wl,--no-entry -Wl,--export=pack -Wl,--export=malloc -Wl,--export=free -Wl,--export=__wasm_call_ctors -Wl,-s -Wl,--allow-undefined-file=gltf/wasistubs.txt

build/decoder_base.wasm: $(WASM_DECODER_SOURCES)
	@mkdir -p build
	$(WASMCC) $^ $(WASM_FLAGS) $(patsubst %,$(WASM_EXPORT_PREFIX)=%,$(WASM_DECODER_EXPORTS)) -o $@

build/decoder_simd.wasm: $(WASM_DECODER_SOURCES)
	@mkdir -p build
	$(WASMCC) $^ $(WASM_FLAGS) $(patsubst %,$(WASM_EXPORT_PREFIX)=%,$(WASM_DECODER_EXPORTS)) -o $@ -msimd128 -mbulk-memory

build/encoder.wasm: $(WASM_ENCODER_SOURCES)
	@mkdir -p build
	$(WASMCC) $^ $(WASM_FLAGS) $(patsubst %,$(WASM_EXPORT_PREFIX)=%,$(WASM_ENCODER_EXPORTS)) -lc -o $@

build/simplifier.wasm: $(WASM_SIMPLIFIER_SOURCES)
	@mkdir -p build
	$(WASMCC) $^ $(WASM_FLAGS) $(patsubst %,$(WASM_EXPORT_PREFIX)=%,$(WASM_SIMPLIFIER_EXPORTS)) -lc -o $@

build/clusterizer.wasm: $(WASM_CLUSTERIZER_SOURCES)
	@mkdir -p build
	$(WASMCC) $^ $(WASM_FLAGS) $(patsubst %,$(WASM_EXPORT_PREFIX)=%,$(WASM_CLUSTERIZER_EXPORTS)) -lc -o $@

js/meshopt_decoder.js: build/decoder_base.wasm build/decoder_simd.wasm tools/wasmpack.py
	sed -i "s#Built with clang.*#Built with $$($(WASMCC) --version | head -n 1 | sed 's/\s\+(.*//')#" $@
	sed -i "s#Built from meshoptimizer .*#Built from meshoptimizer $$(cat src/meshoptimizer.h | grep -Po '(?<=version )[0-9.]+')#" $@
	sed -i "s#\([\"']\).*\(;\s*//\s*embed! base\)#\\1$$(cat build/decoder_base.wasm | python3 tools/wasmpack.py)\\1\\2#" $@
	sed -i "s#\([\"']\).*\(;\s*//\s*embed! simd\)#\\1$$(cat build/decoder_simd.wasm | python3 tools/wasmpack.py)\\1\\2#" $@

js/meshopt_encoder.js: build/encoder.wasm tools/wasmpack.py
js/meshopt_simplifier.js: build/simplifier.wasm tools/wasmpack.py
js/meshopt_clusterizer.js: build/clusterizer.wasm tools/wasmpack.py

js/meshopt_encoder.js js/meshopt_simplifier.js js/meshopt_clusterizer.js:
	sed -i "s#Built with clang.*#Built with $$($(WASMCC) --version | head -n 1 | sed 's/\s\+(.*//')#" $@
	sed -i "s#Built from meshoptimizer .*#Built from meshoptimizer $$(cat src/meshoptimizer.h | grep -Po '(?<=version )[0-9.]+')#" $@
	sed -i "s#\([\"']\).*\(;\s*//\s*embed! wasm\)#\\1$$(cat $< | python3 tools/wasmpack.py)\\1\\2#" $@

js/%.module.js: js/%.js
	sed '\#// export!#q' <$< >$@
	sed -i "/use strict.;/d" $@
	sed -i "s#// export! \(.*\)#export { \\1 };#" $@

$(DEMO): $(DEMO_OBJECTS) $(LIBRARY)
	$(CXX) $^ $(LDFLAGS) -o $@

vcachetuner: tools/vcachetuner.cpp tools/objloader.cpp $(LIBRARY)
	$(CXX) $^ -fopenmp $(CXXFLAGS) -std=c++11 $(LDFLAGS) -o $@

codecbench: tools/codecbench.cpp $(LIBRARY)
	$(CXX) $^ $(CXXFLAGS) $(LDFLAGS) -o $@

codecbench.js: tools/codecbench.cpp $(LIBRARY_SOURCES)
	emcc $^ -O3 -g -DNDEBUG -s TOTAL_MEMORY=268435456 -s SINGLE_FILE=1 -o $@

codecbench-simd.js: tools/codecbench.cpp $(LIBRARY_SOURCES)
	emcc $^ -O3 -g -DNDEBUG -s TOTAL_MEMORY=268435456 -s SINGLE_FILE=1 -msimd128 -o $@

codecbench.wasm: tools/codecbench.cpp $(LIBRARY_SOURCES)
	$(WASMCC) $^ -fno-exceptions --target=wasm32-wasi --sysroot=$(WASIROOT) -lc++ -lc++abi -O3 -g -DNDEBUG -o $@

codecbench-simd.wasm: tools/codecbench.cpp $(LIBRARY_SOURCES)
	$(WASMCC) $^ -fno-exceptions --target=wasm32-wasi --sysroot=$(WASIROOT) -lc++ -lc++abi -O3 -g -DNDEBUG -msimd128 -o $@

codectest: tools/codectest.cpp $(LIBRARY)
	$(CXX) $^ $(CXXFLAGS) $(LDFLAGS) -o $@

codecfuzz: tools/codecfuzz.cpp src/vertexcodec.cpp src/indexcodec.cpp
	$(CXX) $^ -fsanitize=fuzzer,address,undefined -O1 -g -o $@

simplifyfuzz: tools/simplifyfuzz.cpp src/simplifier.cpp
	$(CXX) $^ -fsanitize=fuzzer,address,undefined -O1 -g -o $@

$(LIBRARY): $(LIBRARY_OBJECTS)
	ar rcs $@ $^

$(BUILD)/amalgamated.so: $(LIBRARY_SOURCES)
	@mkdir -p $(dir $@)
	cat $^ | $(CXX) $(CXXFLAGS) -x c++ - -I src/ -o $@ -shared -fPIC

$(BUILD)/%.cpp.o: %.cpp
	@mkdir -p $(dir $@)
	$(CXX) $< $(CXXFLAGS) -c -MMD -MP -o $@

$(BUILD)/%.c.o: %.c
	@mkdir -p $(dir $@)
	$(CC) $< $(CFLAGS) -c -MMD -MP -o $@

-include $(OBJECTS:.o=.d)

clean:
	rm -rf $(BUILD)

.PHONY: all clean format js

=== debian/changelog ===
meshoptimizer (0.22+dfsg-1) unstable; urgency=medium

  * Update d/watch to latest GitHub recipe
  * New upstream version 0.22+dfsg
  * Refresh patches (no functional changes)
  * Update d/symbols
  * Bump Standards-Version to 4.7.0
  * Wrap and sort Debian package files

 -- Timo Röhling <roehling@debian.org>  Fri, 29 Nov 2024 11:39:33 +0100

=== debian/control ===
Source: meshoptimizer
Section: graphics
Priority: optional
Maintainer: Timo Röhling <roehling@debian.org>
Build-Depends:
 cmake,
 debhelper-compat (= 13),
Homepage: https://github.com/zeux/meshoptimizer
Standards-Version: 4.7.0
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/roehling/meshoptimizer.git
Vcs-Browser: https://salsa.debian.org/roehling/meshoptimizer

Package: libmeshoptimizer2d
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Mesh optimizing library for 3D object rendering
 When a GPU renders triangle meshes, various stages of the GPU pipeline have
 to process vertex and index data. The efficiency of these stages depends on
 the data you feed to them; this library provides algorithms to help optimize
 meshes for these stages, as well as algorithms to reduce the mesh complexity
 and storage overhead.

Package: gltfpack
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: glTF mesh file optimizer
 gltfpack is a tool that can automatically optimize glTF files to reduce the
 download size and improve loading and rendering speed.
 .
 It substantially changes the glTF data by optimizing the meshes for
 vertex fetch and transform cache, quantizing the geometry to reduce the
 memory consumption and size, merging meshes to reduce the draw call count,
 quantizing and resampling animations to reduce animation size and simplify
 playback, and pruning the node tree by removing or collapsing redundant
 nodes. It will also simplify the meshes when requested to do so.

Package: libmeshoptimizer-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libmeshoptimizer2d (= ${binary:Version}),
 ${misc:Depends},
Description: Mesh optimizing library for 3D object rendering - development headers
 When a GPU renders triangle meshes, various stages of the GPU pipeline have
 to process vertex and index data. The efficiency of these stages depends on
 the data you feed to them; this library provides algorithms to help optimize
 meshes for these stages, as well as algorithms to reduce the mesh complexity
 and storage overhead.
 .
 This package provides the development headers for the library.

=== debian/watch ===
version=4
opts=\
 filenamemangle=s%.*/@ANY_VERSION@%@PACKAGE@-$1.tar.gz%,\
 downloadurlmangle=s%(api.github.com/repos/[^/]+/[^/]+)/git/refs/%$1/tarball/refs/%g,\
 dversionmangle=auto,oversionmangle=s%$%+dfsg%,\
 repack,\
 searchmode=plain \
 https://api.github.com/repos/zeux/meshoptimizer/git/matching-refs/tags/ \
 https://api.github.com/repos/[^/]+/[^/]+/git/refs/tags/@ANY_VERSION@

## meshoptimizer 0.25%2Bdfsg

=== debian/changelog ===
meshoptimizer (0.25+dfsg-1) experimental; urgency=medium

  * Migrate debian/watch to version 5 format
  * New upstream version 0.25+dfsg
  * Update patches
    - Obsolete: 0002-Remove-debug-code.patch
  * Wrap and sort Debian files
  * Bump Standards-Version to 4.7.2
  * Bump SONAME to 3d

 -- Timo Röhling <roehling@debian.org>  Tue, 16 Sep 2025 22:07:45 +0200

=== debian/rules ===
--- 
+++ 
@@ -10,5 +10,5 @@
 		-DMESHOPT_BUILD_DEMO=OFF \
 		-DMESHOPT_BUILD_GLTFPACK=ON \
 		-DMESHOPT_BUILD_SHARED_LIBS=ON \
-		-DMESHOPT_SOVERSION=2d \
+		-DMESHOPT_SOVERSION=3d \
 		-DCMAKE_SKIP_RPATH=ON
